//Titel:        JTree
//Copyright:     Copyright (c) 2003, 06, 2010
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einführung in JTree
//Version:       2.0
//letzte Aenderung: 07.11.2010


// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNodeRec liefert Zusatzinformationen, mit toString
// Klick Ereignis, Single bzw. Double-Click


import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.tree.*;

import javax.swing.event.*;

import java.io.*;

import java.util.Vector;

public class Tree07 extends JFrame {

  JTree jTree1;
  DefaultMutableTreeNode rootNode;
  DefaultTreeModel treeModel;
  TreePath RootPath;


  public Tree07() {
    setSize(400, 300);
    setTitle("JTree 7. Beispiel");
    this.setLocation(500,300);
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
  }

    // wird vom Tree aufgerufen,
    // hier muesste man weitere Dialogfenster aufrufen
   public void CreateAktionFromTreeNode( int i ) {
    System.out.println("in Methode CreateAktionFromTreeNode, ID: "+i);
   }



  private void setGUI()  {
    this.getContentPane().setLayout( new BorderLayout() );
    rootNode = BuildTree();

    treeModel = new DefaultTreeModel(rootNode);
    jTree1 = new javax.swing.JTree(treeModel);  //  kein Root !!!
   jTree1.setFont( new Font("Arial", Font.BOLD,22)  );
 

    jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    // jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
   //  SINGLE_TREE_SELECTION, CONTIGUOUS_TREE_SELECTION or DISCONTIGUOUS_TREE_SELECTION.


    jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTree1_mouseClicked(e);
      }
    });


    jTree1.setBorder(BorderFactory.createLineBorder(Color.black));
    jTree1.setToolTipText("ToolTipp");
    jTree1.setShowsRootHandles(true);

      // Horizontale Linien
    jTree1.putClientProperty("JTree.lineStyle","Horizontal");
      // Mit Linien zwischen den Knoten
    jTree1.putClientProperty("JTree.lineStyle","Angled");

    this.getContentPane().add( new JScrollPane(jTree1), BorderLayout.CENTER);

  }  // setGUI
              

  void jTree1_mouseClicked(MouseEvent e) {
    int selRow = jTree1.getRowForLocation(e.getX(), e.getY());
    TreePath selPath = jTree1.getPathForLocation(e.getX(), e.getY());
    if(selRow != -1) {
       if(e.getClickCount() == 1) {
           SingleClick(selRow, selPath);
       }
       else if(e.getClickCount() == 2) {
           DoubleClick(selRow, selPath);
      }
    }
  }

  void  SingleClick(int selRow, TreePath selPath) {
    System.out.println("CSingleClick: "+selRow);
  }


   // Doppelklick, abpruefen ob ein echter Knoten
   // ID > 2, dann Aufruf CreateAktionFromTreeNode
 void  DoubleClick(int selRow, TreePath selPath) {
    DefaultMutableTreeNode node;
    CTreeNodeRec CNode;
    node = (DefaultMutableTreeNode) jTree1.getLastSelectedPathComponent();
    if (node == null) {
       return;
    }
    else {
      CNode = (CTreeNodeRec) node.getUserObject();
      System.out.println("CDoubleClick: "+node.toString()+" \n" +CNode.getData() );
      if ( CNode.getData()>2 ) {
	      // Aufruf und Erzeugen eines Dialogfensters
         CreateAktionFromTreeNode( CNode.getData() );
         setTitle("Data größer 2");
      }
      else {
        setTitle("Data kleiner gleich 2");
      }
    }
  }
  

  // ----------------------------
  DefaultMutableTreeNode BuildTree() {
    DefaultMutableTreeNode root;
    DefaultMutableTreeNode Kn0, Kn1, Kn2;

    root = createCNode(  0,"root");  // new DefaultMutableTreeNode("root");

      // liefert einen DefaultMutableTreeNode
    Kn0 = createCNode(  1,"1. Stufe (1)");
    root.add( Kn0 );

    Kn1 = createCNode(  2,"AAA");
    Kn0.add( Kn1 );  // Parameter Vater
    Kn1 = createCNode(  3,"BBB");
    Kn0.add( Kn1 );  // Parameter Vater


    // ---------

    Kn0 = createCNode(  2,"1. Stufe (2)");
    root.add( Kn0 );

    Kn1 = createCNode(  6,"CCC");
    Kn0.add( Kn1 );  // Parameter Vater
    Kn1 = createCNode(  2,"DDDD");
    Kn0.add( Kn1 );  // Parameter Vater


    Kn0 = createCNode(  3,"1. Stufe (3)");
    root.add( Kn0 );

    Kn1 = createCNode(  6,"EEE");
    Kn0.add( Kn1 );  // Parameter Vater

      Kn2 = createCNode(  7,"E1E1E1");
      Kn1.add( Kn2 );  // Parameter Vater
      Kn2 = createCNode(  2,"E2E2E2");
      Kn1.add( Kn2 );  // Parameter Vater

    Kn1 = createCNode(  11,"FFF");
    Kn0.add( Kn1 );  // Parameter Vater
      Kn2 = createCNode(  2,"F1F1F1");
      Kn1.add( Kn2 );  // Parameter Vater
      Kn2 = createCNode(  4,"F2F2F2");
      Kn1.add( Kn2 );  // Parameter Vater

    return root;
  }  // BuildTree




 DefaultMutableTreeNode createCNode(int CData,  String nodeString) {
    CTreeNodeRec CNode;
    DefaultMutableTreeNode Node;

    CNode = new  CTreeNodeRec(CData, nodeString);
    Node = new DefaultMutableTreeNode(CNode);
    // Alternative:
    // Node = new DefaultMutableTreeNode(nodeString);
    //Node.setUserObject(CNode);
    return Node;
 }



  public static void main(String[] args) {
    Tree07 frame = new Tree07();
    frame.setVisible(true);
 }


}




// Einfache Klasse für jeden Knoten
class CTreeNodeRec  {
  public static long nr=0;

    private long _id = 0; // Id des Knotens  z.B. als ID

    private int _CData;

    public String _nodeString;


   public CTreeNodeRec(int CData,  String nodeString) {
      _CData = CData;
      _nodeString = nodeString;  // für JTree;
      nr++;
      _id = nr;  // setzt eindeutige Nummer
   }


   public long getID() {
     return _id;
   }


   public int getData() {
    return _CData;
   }

   public void setData(int CData) {
     _CData = CData;
   }

   // sehr wichtig
   public String toString() {
     return _nodeString;
   }

}  // CTreeNodeRec



